---
AWSTemplateFormatVersion: "2010-09-09"
Description: "Creates a VPC peering connection of specified VPCs in same AWS Account"
Parameters:
  EnvironmentAbbr:
    Description: "Environment abbreviation"
    Type       : "String"
  VPCPeeringId:
    Type       : "String"
  PeerCidrBlock:
    Type       : "String"

Conditions:
  # Source VPC conditions
  SourceHasPublicSubnets:
    Fn::Equals:
      - {{ 'SubnetsPublic' in vpc_peers[environment_abbr + '-vpc']['stack_outputs'] }}
      - True
  SourceHasDatabaseSubnets:
    Fn::Equals:
      - {{ 'SubnetsDatabase' in vpc_peers[environment_abbr + '-vpc']['stack_outputs']}}
      - True
  SourceHasPrivateSubnets:
    Fn::Equals:
      - {{ 'SubnetsPrivate' in vpc_peers[environment_abbr + '-vpc']['stack_outputs']}}
      - True
{% for peer in aws_vpc_peering_params.peers %}
  # {{ peer.environment_abbr }} VPC conditions
  {{ peer.environment_abbr }}HasPublicSubnets:
    Fn::Equals:
      - {{ 'SubnetsPublic' in vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs']}}
      - True
  {{ peer.environment_abbr }}HasDatabaseSubnets:
    Fn::Equals:
      - {{ 'SubnetsDatabase' in vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs']}}
      - True
  {{ peer.environment_abbr }}HasPrivateSubnets:
    Fn::Equals:
      - {{ 'SubnetsPrivate' in vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs']}}
      - True
{% endfor %}

Resources:
{% for peer in aws_vpc_peering_params.peers %}

#########################################
#                                       #
# Routes on target VPC                  #
#                                       #
#########################################
  VPCPeer{{ peer.environment_abbr | capitalize | replace('-', '') }}To{{ environment_abbr | capitalize | replace('-', '') }}RoutePublic:
    Type: "AWS::EC2::Route"
    Condition: "{{ peer.environment_abbr }}HasPublicSubnets"
    Properties:
      DestinationCidrBlock: !Ref PeerCidrBlock
      RouteTableId: !ImportValue "{{ peer.environment_abbr }}-vpc-RouteTablePublicID"
      VpcPeeringConnectionId: !Ref VPCPeeringId
{% for az in peering_azlist %}
  VPCPeer{{ peer.environment_abbr | capitalize | replace('-', '') }}To{{ environment_abbr | capitalize | replace('-', '') }}RoutePrivate{{ loop.index }}:
    Type: "AWS::EC2::Route"
    Condition: "{{ peer.environment_abbr }}HasPrivateSubnets"
    Properties:
      DestinationCidrBlock: !Ref PeerCidrBlock
      RouteTableId: !ImportValue "{{ peer.environment_abbr }}-vpc-RouteTablePrivate{{ loop.index }}ID"
      VpcPeeringConnectionId: !Ref VPCPeeringId
  VPCPeer{{ peer.environment_abbr | capitalize | replace('-', '') }}To{{ environment_abbr | capitalize | replace('-', '') }}RouteDatabase{{ loop.index }}:
    Type: "AWS::EC2::Route"
    Condition: "{{ peer.environment_abbr }}HasDatabaseSubnets"
    Properties:
      DestinationCidrBlock: !Ref PeerCidrBlock
      RouteTableId: !ImportValue "{{ peer.environment_abbr }}-vpc-RouteTableDatabase{{ loop.index }}ID"
      VpcPeeringConnectionId: !Ref VPCPeeringId

{% endfor %}

#########################################
#                                       #
# ACLs on target VPC                    #
#                                       #
#########################################
{% set count = 100 + loop.index0 %}
  AclInPeer{{ peer.environment_abbr | capitalize | replace('-', '') }}From{{ environment_abbr | capitalize | replace('-', '') }}PublicTCPEphemeral:
    Type: "AWS::EC2::NetworkAclEntry"
    Condition: "{{ peer.environment_abbr }}HasPublicSubnets"
    Properties:
      RuleNumber: "{{ count }}"
      Protocol: 6
      CidrBlock: !Ref PeerCidrBlock
      PortRange:
        From: 1025
        To: 65535
      RuleAction: "allow"
      NetworkAclId: !ImportValue "{{ peer.environment_abbr }}-vpc-AclPublicID"
  AclInPeer{{ peer.environment_abbr | capitalize | replace('-', '') }}From{{ environment_abbr | capitalize | replace('-', '') }}PrivateTCPEphemeral:
    Type: "AWS::EC2::NetworkAclEntry"
    Condition: "{{ peer.environment_abbr }}HasPrivateSubnets"
    Properties:
      RuleNumber: "{{ count }}"
      Protocol: 6
      CidrBlock: !Ref PeerCidrBlock
      PortRange:
        From: 1025
        To: 65535
      RuleAction: "allow"
      NetworkAclId: !ImportValue "{{ peer.environment_abbr }}-vpc-AclPrivateID"
  AclInPeer{{ peer.environment_abbr | capitalize | replace('-', '') }}From{{ environment_abbr | capitalize | replace('-', '') }}DatabaseTCPEphemeral:
    Type: "AWS::EC2::NetworkAclEntry"
    Condition: "{{ peer.environment_abbr }}HasDatabaseSubnets"
    Properties:
      RuleNumber: "{{ count }}"
      Protocol: 6
      CidrBlock: !Ref PeerCidrBlock
      PortRange:
        From: 1025
        To: 65535
      RuleAction: "allow"
      NetworkAclId: !ImportValue "{{ peer.environment_abbr }}-vpc-AclDatabaseID"

{% endfor %}
